﻿using Syncfusion.UI.Xaml.TreeGrid.Helpers;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.TreeGrid;
using Syncfusion.UI.Xaml.ScrollAxis;
using Windows.UI;
using Syncfusion.UI.Xaml.Grid.Cells;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace App1
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        TreeViewModel viewModel;
        public MainPage()
        {
            this.InitializeComponent();
            this.viewModel = this.treeGrid.DataContext as TreeViewModel;
            this.treeGrid.Loaded += TreeGrid_Loaded;
            this.treeGrid.Unloaded += TreeGrid_Unloaded;
            this.treeGrid.SelectionController = new TreeGridSelectionControllerExt(this.treeGrid);
        }

        private void TreeGrid_Unloaded(object sender, RoutedEventArgs e)
        {
            this.treeGrid.RequestTreeItems -= treeGrid_RequestChildSource;
            this.treeGrid.RepopulateTree();
        }

        private void TreeGrid_Loaded(object sender, RoutedEventArgs e)
        {
            this.treeGrid.RequestTreeItems += treeGrid_RequestChildSource;
            this.treeGrid.RepopulateTree();
            this.treeGrid.ExpandNode(1);
        }

        private void treeGrid_RequestChildSource(object sender, TreeGridRequestTreeItemsEventArgs args)
        {
            if (args.ParentItem == null)
            {
                args.ChildItems = viewModel.ItemsCollection;
            }
            else
            {
                args.ChildItems = viewModel.GetSubItems((args.ParentItem as TreeModel).Name);
            }
        }
    }

    internal class ImageConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var datacontext = value as DataContextHelper;
            if (datacontext.Value.ToString() == "Inbox" || datacontext.Value.ToString() == "Drafts" || datacontext.Value.ToString() == "Sent Items"
                || datacontext.Value.ToString() == "Deleted Items" || datacontext.Value.ToString() == "Calendar" || datacontext.Value.ToString() == "Contacts")
                return "ms-appx:///Images///" + datacontext.Value.ToString() + ".png";
            return "ms-appx:///Images///" + "Folder.png";

        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            return null;
        }
    }
}

